#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <clientprefs>
#include <vip_core>

public Plugin:myinfo = 
{
	name = "[VIP] Equipments",
	author = "R1KO",
	version = "1.0.1"
};

static const String:g_sFeature[][] = {"Equipments", "EquipmentsMenu"};

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature[0], BOOL, _, OnItemToggle);
	VIP_RegisterFeature(g_sFeature[1], _, SELECTABLE, OnItemSelect, _, OnItemDraw);
}

public Action:OnItemToggle(iClient, const String:sFeatureName[], VIP_ToggleState:OldStatus, &VIP_ToggleState:NewStatus)
{
	if(NewStatus == ENABLED)
	{
		AllEquipClient(iClient);
	}
	else
	{
		RemoveAllEquipClient(iClient);
	}

	return Plugin_Continue;
}

public bool:OnItemSelect(iClient, const String:sFeatureName[])
{
	DisplayEquipmentsMenu(iClient);

	return false;
}

public OnItemDraw(iClient, const String:sFeatureName[], iStyle)
{
	switch(VIP_GetClientFeatureStatus(iClient, g_sFeature[0]))
	{
		case ENABLED: return ITEMDRAW_DEFAULT;
		case DISABLED: return ITEMDRAW_DISABLED;
		case NO_ACCESS: return ITEMDRAW_RAWLINE;
	}

	return iStyle;
}

new Handle:g_hKeyValues;
new Handle:g_hArrayKeys;
new bool:g_bIsCSGO;
new Float:g_fPreviewDuration;

new Handle:g_hTimer[MAXPLAYERS+1];
new bool:g_bPreview[MAXPLAYERS+1];

public OnPluginStart()
{
	HookEvent("player_death",	Event_RemoveEquip);
	HookEvent("player_team",	Event_RemoveEquip);
	
	g_hArrayKeys = CreateArray(ByteCountToCells(64));
	
	LoadTranslations("vip_modules.phrases.txt");
}

public OnMapStart()
{
	if(g_hKeyValues != INVALID_HANDLE)
	{
		CloseHandle(g_hKeyValues);
	}

	ClearArray(g_hArrayKeys);

	decl String:sBuffer[256];
	GetGameFolderName(sBuffer, 32);
	g_bIsCSGO = (strcmp(sBuffer, "csgo") == 0);

	g_hKeyValues = CreateKeyValues("Equipments");

	BuildPath(Path_SM, sBuffer, sizeof(sBuffer), "data/vip/modules/equipments.ini");
	if (FileToKeyValues(g_hKeyValues, sBuffer) == false)
	{
		CloseHandle(g_hKeyValues);
		SetFailState("Couldn't parse file '%s'", sBuffer);
		return;
	}

	KvRewind(g_hKeyValues);
	g_fPreviewDuration = KvGetFloat(g_hKeyValues, "preview_duration", 3.0);

	if(KvGotoFirstSubKey(g_hKeyValues))
	{
		decl String:sModel[256], Handle:hCookie;
		do
		{
			KvGetSectionName(g_hKeyValues, sModel, 64);
			FormatEx(sBuffer, sizeof(sBuffer), "Equip->%s", sModel);
			
			hCookie = RegClientCookie(sBuffer, sBuffer, CookieAccess_Protected);
			KvSetNum(g_hKeyValues, "cookie", _:hCookie);
			PushArrayString(g_hArrayKeys, sBuffer);

			if(KvGotoFirstSubKey(g_hKeyValues))
			{
				do
				{
					KvSetNum(g_hKeyValues, "loaded", 0);
					KvGetString(g_hKeyValues, "model", sModel, sizeof(sModel));
					if(sModel[0] && (FileExists(sModel) || FileExists(sModel, true)))
					{
						PrecacheModel(sModel, true);
						if(IsModelPrecached(sModel))
						{
							KvSetNum(g_hKeyValues, "loaded", 1);
						}
					}
				} while(KvGotoNextKey(g_hKeyValues));

				KvGoBack(g_hKeyValues);
			}
		} while(KvGotoNextKey(g_hKeyValues));
	}
}

DisplayEquipmentsMenu(iClient)
{
	SetGlobalTransTarget(iClient);

	decl String:sBuffer[128], Handle:hMenu;
	hMenu = CreateMenu(EquipmentsMenu_Handler);
	SetMenuExitBackButton(hMenu, true);
	SetMenuTitle(hMenu, "%t:\n ", g_sFeature[1]);

	decl String:sClientLang[3], String:sServerLang[3];
	GetLanguageInfo(GetClientLanguage(iClient), sClientLang, sizeof(sClientLang));
	GetLanguageInfo(GetServerLanguage(), sServerLang, sizeof(sServerLang));

	KvRewind(g_hKeyValues);

	if(KvGotoFirstSubKey(g_hKeyValues))
	{
		decl String:sItemInfo[64], String:sDisplay[128], String:sClientValue[128], Handle:hTrie;
		hTrie = VIP_GetVIPClientTrie(iClient);
		do
		{
			KvGetSectionName(g_hKeyValues, sItemInfo, sizeof(sItemInfo));
			KvGetString(g_hKeyValues, sClientLang, sDisplay, sizeof(sDisplay));
			if (!sDisplay[0])
			{
				KvGetString(g_hKeyValues, sServerLang, sDisplay, sizeof(sDisplay));
				if (!sDisplay[0])
				{
					strcopy(sDisplay, sizeof(sDisplay), sItemInfo);
				}
			}

			FormatEx(sBuffer, sizeof(sBuffer), "Equip->%s", sItemInfo);
			if(GetTrieString(hTrie, sBuffer, sClientValue, sizeof(sClientValue)))
			{
				if(KvJumpToKey(g_hKeyValues, sClientValue))
				{
					KvGetString(g_hKeyValues, "name", sBuffer, sizeof(sBuffer));
					if(!sBuffer[0])
					{
						KvGetSectionName(g_hKeyValues, sBuffer, sizeof(sBuffer));
					}
					Format(sDisplay, sizeof(sDisplay), "%s [%s]", sDisplay, sBuffer);

					KvGoBack(g_hKeyValues);
				}
				/*
				else
				{
					strcopy(sBuffer, sizeof(sBuffer), "Не выбрано");
					
				}
				*/
			}
			AddMenuItem(hMenu, sItemInfo, sDisplay);

		} while(KvGotoNextKey(g_hKeyValues));
	}

	DisplayMenu(hMenu, iClient, MENU_TIME_FOREVER);
}

public EquipmentsMenu_Handler(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_End: CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) VIP_SendClientVIPMenu(iClient);
		}
		case MenuAction_Select:
		{
			decl String:sItemInfo[64];
			GetMenuItem(hMenu, Item, sItemInfo, sizeof(sItemInfo));
			SetTrieString(VIP_GetVIPClientTrie(iClient), "EquipCategory", sItemInfo);

			DisplayCategoryMenu(iClient);
		}
	}
}

DisplayCategoryMenu(iClient, Item = 0)
{
	SetGlobalTransTarget(iClient);

	decl String:sBuffer[128], Handle:hMenu, Handle:hTrie;
	hMenu = CreateMenu(CategoryMenu_Handler);
	SetMenuExitBackButton(hMenu, true);
	hTrie = VIP_GetVIPClientTrie(iClient);
	GetTrieString(hTrie, "EquipCategory", sBuffer, sizeof(sBuffer));

	KvRewind(g_hKeyValues);
	if(KvJumpToKey(g_hKeyValues, sBuffer))
	{
		decl String:sClientLang[3], String:sServerLang[3], String:sItemInfo[64], String:sDisplay[128], String:sClientValue[128];
		GetLanguageInfo(GetClientLanguage(iClient), sClientLang, sizeof(sClientLang));
		GetLanguageInfo(GetServerLanguage(), sServerLang, sizeof(sServerLang));
		
		KvGetSectionName(g_hKeyValues, sItemInfo, sizeof(sItemInfo));
		KvGetString(g_hKeyValues, sClientLang, sDisplay, sizeof(sDisplay));
		if (!sDisplay[0])
		{
			KvGetString(g_hKeyValues, sServerLang, sDisplay, sizeof(sDisplay));
			if (!sDisplay[0])
			{
				strcopy(sDisplay, sizeof(sDisplay), sItemInfo);
			}
		}

		SetMenuTitle(hMenu, "%s:\n ", sDisplay);

		if(KvGotoFirstSubKey(g_hKeyValues))
		{
			FormatEx(sBuffer, sizeof(sBuffer), "Equip->%s", sItemInfo);
			sClientValue[0] = 0;
			
			if(GetTrieString(hTrie, sBuffer, sClientValue, sizeof(sClientValue)) && sClientValue[0])
			{
				AddMenuItem(hMenu, "none", "Выключить\n ");
			}

			do
			{
				if(!KvGetNum(g_hKeyValues, "loaded"))
				{
					continue;
				}

				KvGetString(g_hKeyValues, "name", sDisplay, sizeof(sDisplay));
				KvGetSectionName(g_hKeyValues, sBuffer, sizeof(sBuffer));
				if(!sDisplay[0])
				{
					strcopy(sDisplay, sizeof(sDisplay), sBuffer);
				}

				if(sClientValue[0] && strcmp(sBuffer, sClientValue) == 0)
				{
					StrCat(sDisplay, sizeof(sDisplay), " [X]");
					AddMenuItem(hMenu, "", sDisplay, ITEMDRAW_DISABLED);
					continue;
				}

				AddMenuItem(hMenu, sBuffer, sDisplay);
			} while(KvGotoNextKey(g_hKeyValues));
		}
	}

	if(GetMenuItemCount(hMenu) == 0)
	{
		AddMenuItem(hMenu, "", "Нет предметов", ITEMDRAW_DISABLED);
	}

	DisplayMenuAtItem(hMenu, iClient, Item, MENU_TIME_FOREVER);
}

public CategoryMenu_Handler(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_End: CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) DisplayEquipmentsMenu(iClient);
		}
		case MenuAction_Select:
		{
			decl Handle:hTrie, String:sBuffer[256], String:sCategory[128], String:sItemInfo[128];
			GetMenuItem(hMenu, Item, sItemInfo, sizeof(sItemInfo));
			
			hTrie = VIP_GetVIPClientTrie(iClient);
			
			GetTrieString(hTrie, "EquipCategory", sCategory, sizeof(sCategory));
			
			KvRewind(g_hKeyValues);
			if(KvJumpToKey(g_hKeyValues, sCategory))
			{
				FormatEx(sBuffer, sizeof(sBuffer), "Equip->%s", sCategory);
				if(strcmp(sItemInfo, "none") == 0)
				{
					RemoveFromTrie(hTrie, sBuffer);
					SetClientCookie(iClient, Handle:KvGetNum(g_hKeyValues, "cookie"), "");
					
					if(IsPlayerAlive(iClient))
					{
						RemoveEquipClient(iClient, sBuffer);
					}
				}
				else
				{
					SetTrieString(hTrie, sBuffer, sItemInfo);
					SetClientCookie(iClient, Handle:KvGetNum(g_hKeyValues, "cookie"), sItemInfo);
					
					if(IsPlayerAlive(iClient))
					{
						RemoveEquipClient(iClient, sBuffer);
						EquipClient(iClient, sBuffer);
						
						if(g_fPreviewDuration)
						{
							if (g_hTimer[iClient] != INVALID_HANDLE)
							{
								KillTimer(g_hTimer[iClient]);
								g_hTimer[iClient] = INVALID_HANDLE;
							}

							g_hTimer[iClient] = CreateTimer(g_fPreviewDuration, Timer_SetBackMode, iClient, TIMER_FLAG_NO_MAPCHANGE);

							SetThirdPersonMode(iClient, true);
						}
					}
				}
			}

			DisplayCategoryMenu(iClient, GetMenuSelectionPosition());
		}
	}
}

public Action:Timer_SetBackMode(Handle:hTimer, any:iClient)
{
	SetThirdPersonMode(iClient, false);
	g_hTimer[iClient] = INVALID_HANDLE;
}

public OnClientDisconnect(iClient)
{
	g_bPreview[iClient] = false;

	if (g_hTimer[iClient] != INVALID_HANDLE)
	{
		KillTimer(g_hTimer[iClient]);
		g_hTimer[iClient] = INVALID_HANDLE;
	}
}

public VIP_OnVIPClientLoaded(iClient)
{
	if(VIP_GetClientFeatureStatus(iClient, g_sFeature[0]) != NO_ACCESS)
	{
		if(AreClientCookiesCached(iClient))
		{
			LoadEquip(iClient);
		}
		else
		{
			CreateTimer(1.0, Timer_CheckCookies, GetClientUserId(iClient), TIMER_FLAG_NO_MAPCHANGE);
		}
	}
}

public Action:Timer_CheckCookies(Handle:hTimer, any:UserID)
{
	new iClient = GetClientOfUserId(UserID);
	if(iClient && VIP_IsClientVIP(iClient) && VIP_GetClientFeatureStatus(iClient, g_sFeature[0]) != NO_ACCESS)
	{
		if(AreClientCookiesCached(iClient))
		{
			LoadEquip(iClient);

			return Plugin_Stop;
		}
		
		CreateTimer(1.0, Timer_CheckCookies, UserID, TIMER_FLAG_NO_MAPCHANGE);
	}
	
	return Plugin_Stop;
}

public Event_RemoveEquip(Handle:hEvent, const String:sEvName[], bool:dBontBroadcast)
{
	new iClient = GetClientOfUserId(GetEventInt(hEvent, "userid"));

	if(VIP_IsClientVIP(iClient) && VIP_IsClientFeatureUse(iClient, g_sFeature[0]))
	{
		RemoveAllEquipClient(iClient);
	}
}

public VIP_OnPlayerSpawn(iClient, iTeam, bool:bIsVIP)
{
	if(bIsVIP && VIP_IsClientFeatureUse(iClient, g_sFeature[0]))
	{
		AllEquipClient(iClient);
	}
}

LoadEquip(iClient)
{
	new iSize = GetArraySize(g_hArrayKeys);
	if(iSize)
	{
		decl String:sKey[256], String:sBuffer[128], Handle:hTrie, Handle:hCookie, i;
		hTrie = VIP_GetVIPClientTrie(iClient);

		for(i = 0; i < iSize; ++i)
		{
			GetArrayString(g_hArrayKeys, i, sKey, sizeof(sKey));
			KvRewind(g_hKeyValues);
			if(KvJumpToKey(g_hKeyValues, sKey[7]))
			{
				hCookie = Handle:KvGetNum(g_hKeyValues, "cookie");
				GetClientCookie(iClient, hCookie, sBuffer, sizeof(sBuffer));
				if(sBuffer[0])
				{
					if(KvJumpToKey(g_hKeyValues, sBuffer))
					{
						if(KvGetNum(g_hKeyValues, "loaded"))
						{
							SetTrieString(hTrie, sKey, sBuffer);
							continue;
						}
					}

					SetClientCookie(iClient, hCookie, "");
				}
			}
		}
	}
}

RemoveAllEquipClient(iClient)
{
	new iSize = GetArraySize(g_hArrayKeys);
	if(iSize)
	{
		decl String:sKey[128], Handle:hTrie, i, iEntity;
		hTrie = VIP_GetVIPClientTrie(iClient);

		for(i = 0; i < iSize; ++i)
		{
			GetArrayString(g_hArrayKeys, i, sKey, sizeof(sKey));
			Format(sKey, sizeof(sKey), "%s->index", sKey);
			if(GetTrieValue(hTrie, sKey, iEntity))
			{
				RemoveFromTrie(hTrie, sKey);
				if(iEntity && IsValidEntity(iEntity))
				{
					SDKUnhook(iEntity, SDKHook_SetTransmit, ShouldHide);
					AcceptEntityInput(iEntity, "Kill");
				}
			}
		}
	}
}

RemoveEquipClient(iClient, const String:sKeyPart[])
{
	decl String:sKey[128], Handle:hTrie, iEntity;
	hTrie = VIP_GetVIPClientTrie(iClient);
	FormatEx(sKey, sizeof(sKey), "%s->index", sKeyPart);
	if(GetTrieValue(hTrie, sKey, iEntity))
	{
		RemoveFromTrie(hTrie, sKey);
		if(iEntity && IsValidEntity(iEntity))
		{
			SDKUnhook(iEntity, SDKHook_SetTransmit, ShouldHide);
			AcceptEntityInput(iEntity, "Kill");
		}
	}
}

AllEquipClient(iClient)
{
	new iSize = GetArraySize(g_hArrayKeys);
	if(iSize)
	{
		decl String:sKey[128], String:sItem[128], Handle:hTrie, i, iEntity, bool:bHide;
		hTrie = VIP_GetVIPClientTrie(iClient);

		for(i = 0; i < iSize; ++i)
		{
			GetArrayString(g_hArrayKeys, i, sKey, sizeof(sKey));
			if(GetTrieString(hTrie, sKey, sItem, sizeof(sItem)))
			{
				KvRewind(g_hKeyValues);
				if(KvJumpToKey(g_hKeyValues, sKey[7]))
				{
					bHide = bool:KvGetNum(g_hKeyValues, "hide");
					if(KvJumpToKey(g_hKeyValues, sItem))
					{
						Format(sKey, sizeof(sKey), "%s->index", sKey);
						if(GetTrieValue(hTrie, sKey, iEntity))
						{
							if(IsValidEntity(iEntity))
							{
								SDKUnhook(iEntity, SDKHook_SetTransmit, ShouldHide);
								AcceptEntityInput(iEntity, "Kill");
							}
						}
						iEntity = CreateItem(iClient, bHide);
						SetTrieValue(hTrie, sKey, iEntity);
					}
				}
			}
		}
	}
}

EquipClient(iClient, const String:sKeyPart[])
{
	decl String:sKey[128], String:sItem[128], Handle:hTrie, iEntity, bool:bHide;
	hTrie = VIP_GetVIPClientTrie(iClient);
	if(GetTrieString(hTrie, sKeyPart, sItem, sizeof(sItem)))
	{
		KvRewind(g_hKeyValues);
		if(KvJumpToKey(g_hKeyValues, sKeyPart[7]))
		{
			bHide = bool:KvGetNum(g_hKeyValues, "hide");
			if(KvJumpToKey(g_hKeyValues, sItem))
			{
				FormatEx(sKey, sizeof(sKey), "%s->index", sKeyPart);
				if(GetTrieValue(hTrie, sKey, iEntity))
				{
					if(IsValidEntity(iEntity))
					{
						SDKUnhook(iEntity, SDKHook_SetTransmit, ShouldHide);
						AcceptEntityInput(iEntity, "Kill");
					}
				}
	
				iEntity = CreateItem(iClient, bHide);
				SetTrieValue(hTrie, sKey, iEntity);
			}
		}
	}
}

CreateItem(iClient, bool:bHide)
{
	decl Float:fOrigin[3], Float:fAngles[3], String:sModel[256], String:sAttachment[64];
	
	GetClientModel(iClient, sModel, sizeof(sModel));
	ReplaceString(sModel, sizeof(sModel), "/", "\\");
	if (KvJumpToKey(g_hKeyValues, "playermodels"))
	{
		if (KvJumpToKey(g_hKeyValues, sModel))
		{
			KvGetString(g_hKeyValues, "attachment", sAttachment, sizeof(sAttachment), "facemask");
			KvGetVector(g_hKeyValues, "position", fOrigin);
			KvGetVector(g_hKeyValues, "angles", fAngles);
		}
		else
		{
			KvGoBack(g_hKeyValues);
			KvGetString(g_hKeyValues, "attachment", sAttachment, sizeof(sAttachment), "facemask");
			KvGetVector(g_hKeyValues, "position", fOrigin);
			KvGetVector(g_hKeyValues, "angles", fAngles);
		}
	}
	else
	{
		KvGetString(g_hKeyValues, "attachment", sAttachment, sizeof(sAttachment), "facemask");
		KvGetVector(g_hKeyValues, "position", fOrigin);
		KvGetVector(g_hKeyValues, "angles", fAngles);
	}

	new Float:fItemOrigin[3], Float:fItemAngles[3], Float:fForward[3], Float:fRight[3], Float:fUp[3];
	
	GetClientAbsOrigin(iClient, fItemOrigin);
	GetClientAbsAngles(iClient, fItemAngles);

	fItemAngles[0] += fAngles[0];
	fItemAngles[1] += fAngles[1];
	fItemAngles[2] += fAngles[2];

	GetAngleVectors(fItemAngles, fForward, fRight, fUp);

	fItemOrigin[0] += fRight[0]*fOrigin[0] + fForward[0]*fOrigin[1] + fUp[0]*fOrigin[2];
	fItemOrigin[1] += fRight[1]*fOrigin[0] + fForward[1]*fOrigin[1] + fUp[1]*fOrigin[2];
	fItemOrigin[2] += fRight[2]*fOrigin[0] + fForward[2]*fOrigin[1] + fUp[2]*fOrigin[2];

	new iEntity = CreateEntityByName("prop_dynamic_override");

	KvGetString(g_hKeyValues, "model", sModel, sizeof(sModel));
	DispatchKeyValue(iEntity, "model", sModel);
	DispatchKeyValue(iEntity, "spawnflags", "256");
	DispatchKeyValue(iEntity, "solid", "0");
	SetEntPropEnt(iEntity, Prop_Send, "m_hOwnerEntity", iClient);
	
	if(KvGetNum(g_hKeyValues, "bonemerge"))
	{
		new iEntEffects = GetEntProp(iEntity, Prop_Send, "m_fEffects"); 
		iEntEffects &= ~32;
		iEntEffects |= 1;
		iEntEffects |= 128;
		SetEntProp(iEntity, Prop_Send, "m_fEffects", iEntEffects); 
	}

	DispatchSpawn(iEntity);	
	AcceptEntityInput(iEntity, "TurnOn", iEntity, iEntity, 0);

	new Float:fScale = KvGetFloat(g_hKeyValues, "scale", 1.0);
	if(fScale != 1.0)
	{
		new iScaleOfsset = GetEntSendPropOffs(iEntity, "m_flModelScale", true);
		if(iScaleOfsset != -1)
		{
			SetEntDataFloat(iEntity, iScaleOfsset, fScale, true);
		}
	}

	if(bHide)
	{
		SDKHook(iEntity, SDKHook_SetTransmit, ShouldHide);
	}

	TeleportEntity(iEntity, fItemOrigin, fItemAngles, NULL_VECTOR); 

	SetVariantString("!activator");
	AcceptEntityInput(iEntity, "SetParent", iClient, iEntity, 0);

	SetVariantString(sAttachment);
	AcceptEntityInput(iEntity, "SetParentAttachmentMaintainOffset", iEntity, iEntity, 0);	

	return iEntity;
}

public Action:ShouldHide(iEntity, iClient)
{
	static iOwner;

	iOwner = GetEntPropEnt(iEntity, Prop_Send, "m_hOwnerEntity");
	if (iOwner == iClient && !g_bPreview[iClient])
	{
		return Plugin_Handled;
	}

	/*
	if (GetEntProp(iClient, Prop_Send, "m_iObserverMode") == 4)
	{
		if (iOwner == GetEntPropEnt(iClient, Prop_Send, "m_hObserverTarget"))
		{
			return Plugin_Handled;
		}
	}*/

	return Plugin_Continue;
}

#define HIDE_CROSSHAIR_CSGO 1<<8
#define HIDE_RADAR_CSGO 1<<12

SetThirdPersonMode(iClient, bool:bEnable)
{
	g_bPreview[iClient] = bEnable;
	static Handle:mp_forcecamera;
	if(!mp_forcecamera)
	{
		mp_forcecamera = FindConVar("mp_forcecamera");
	}
	
	if(bEnable)
	{
		
		SetEntPropEnt(iClient, Prop_Send, "m_hObserverTarget", 0); 
		SetEntProp(iClient, Prop_Send, "m_iObserverMode", 1);
		SetEntProp(iClient, Prop_Send, "m_bDrawViewmodel", 0);
		SetEntProp(iClient, Prop_Send, "m_iFOV", 120);
		SendConVarValue(iClient, mp_forcecamera, "1");

		if(g_bIsCSGO)
		{
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") | HIDE_RADAR_CSGO);
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") | HIDE_CROSSHAIR_CSGO);
		}
	}
	else
	{
		SetEntPropEnt(iClient, Prop_Send, "m_hObserverTarget", -1);
		SetEntProp(iClient, Prop_Send, "m_iObserverMode", 0);
		SetEntProp(iClient, Prop_Send, "m_bDrawViewmodel", 1);
		SetEntProp(iClient, Prop_Send, "m_iFOV", 90);
		decl String:sValue[4];
		GetConVarString(mp_forcecamera, sValue, sizeof(sValue));
		SendConVarValue(iClient, mp_forcecamera, sValue);

		if(g_bIsCSGO)
		{
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") & ~HIDE_RADAR_CSGO);
			SetEntProp(iClient, Prop_Send, "m_iHideHUD", GetEntProp(iClient, Prop_Send, "m_iHideHUD") & ~HIDE_CROSSHAIR_CSGO);
		}
	}
}  
